// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package order_web

import (
	context "context"
	order "gitlab.com/fcpartners/apis/gen/order/v1/order"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ExchangeRateServiceClient is the client API for ExchangeRateService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ExchangeRateServiceClient interface {
	GetExchangeRateByCurrency(ctx context.Context, in *order.GetExchangeRateByCurrencyRequest, opts ...grpc.CallOption) (*order.GetExchangeRateByCurrencyResponse, error)
}

type exchangeRateServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewExchangeRateServiceClient(cc grpc.ClientConnInterface) ExchangeRateServiceClient {
	return &exchangeRateServiceClient{cc}
}

func (c *exchangeRateServiceClient) GetExchangeRateByCurrency(ctx context.Context, in *order.GetExchangeRateByCurrencyRequest, opts ...grpc.CallOption) (*order.GetExchangeRateByCurrencyResponse, error) {
	out := new(order.GetExchangeRateByCurrencyResponse)
	err := c.cc.Invoke(ctx, "/fcp.order.v1.order_web.ExchangeRateService/GetExchangeRateByCurrency", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ExchangeRateServiceServer is the server API for ExchangeRateService service.
// All implementations must embed UnimplementedExchangeRateServiceServer
// for forward compatibility
type ExchangeRateServiceServer interface {
	GetExchangeRateByCurrency(context.Context, *order.GetExchangeRateByCurrencyRequest) (*order.GetExchangeRateByCurrencyResponse, error)
	mustEmbedUnimplementedExchangeRateServiceServer()
}

// UnimplementedExchangeRateServiceServer must be embedded to have forward compatible implementations.
type UnimplementedExchangeRateServiceServer struct {
}

func (UnimplementedExchangeRateServiceServer) GetExchangeRateByCurrency(context.Context, *order.GetExchangeRateByCurrencyRequest) (*order.GetExchangeRateByCurrencyResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetExchangeRateByCurrency not implemented")
}
func (UnimplementedExchangeRateServiceServer) mustEmbedUnimplementedExchangeRateServiceServer() {}

// UnsafeExchangeRateServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ExchangeRateServiceServer will
// result in compilation errors.
type UnsafeExchangeRateServiceServer interface {
	mustEmbedUnimplementedExchangeRateServiceServer()
}

func RegisterExchangeRateServiceServer(s grpc.ServiceRegistrar, srv ExchangeRateServiceServer) {
	s.RegisterService(&ExchangeRateService_ServiceDesc, srv)
}

func _ExchangeRateService_GetExchangeRateByCurrency_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(order.GetExchangeRateByCurrencyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExchangeRateServiceServer).GetExchangeRateByCurrency(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.order.v1.order_web.ExchangeRateService/GetExchangeRateByCurrency",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExchangeRateServiceServer).GetExchangeRateByCurrency(ctx, req.(*order.GetExchangeRateByCurrencyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ExchangeRateService_ServiceDesc is the grpc.ServiceDesc for ExchangeRateService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ExchangeRateService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.order.v1.order_web.ExchangeRateService",
	HandlerType: (*ExchangeRateServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetExchangeRateByCurrency",
			Handler:    _ExchangeRateService_GetExchangeRateByCurrency_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/order_web/exchange_rate_web.proto",
}
